/* ****************************************************************************
;                                                                             *
;    Project: SD FOR PICS          				                              *
;    Date: 7/10/2011                               	                          *
;    File Version: 1.0                                                        *
;                                                                             *
;    Author:   Jason Lopez                                                    *
;    Company:  AtomSoftTech                                                   *
;                                                                             *
;******************************************************************************/

#include "main.h"

#pragma config WDT = OFF, LVP = OFF, OSC = HSPLL, XINST = OFF

FATFS fs;
char isMounted = 0;

//Commands for UART
unsigned char CMD[6][5] = {"LIST","READ","WRIT","APND","LIFI","LIDI"};
#define LIST 0
#define READ 1
#define WRITE 2
#define APPEND 3
#define LIST_FILES 4
#define LIST_DIRS 5

/************************************
Main Function
*************************************/
void main(void){
    UINT br;           // File read count
    FRESULT res;       // Petit FatFs function common result code
    UINT temp;

	TRISA = 0x00;
	TRISB = 0x00;
	TRISC = 0x00;
	TRISD = 0x00;
	
	ADCON1 = 0x0F;
	
	Init_UART();

	//UART_STR((rom char*)"UART ONLINE!\n");
	SD_CD_DIR = 1;
	CommandComplete = 0;

	while(1)
	{
      switch(isMounted)
        {
            case 0:
                if(SD_CD)
                    isMounted = 1;
                break;
            case 1:
                if(SD_CD)
                {			
					res = MountSD();
					if(res)
					{
						isMounted = 0;
					}
					else
					{
						isMounted++;
					}
                }
                else
                {
                  isMounted=0;
                }
                break;

            case 2:
                if(SD_CD == 0)
                    isMounted = 0;
                if(CommandComplete==1)
				{
                  RunCommand();
				  CommandComplete = 0;	//Command handled, free it
				  memset(RX_CMD,0,4);
				}
                break;
        }
    }
}

/************************************
Commands
*************************************/
FIL fsrc;
void RunCommand(void)
{
	FRESULT res;
	UINT temp=0;
  	UINT br, bw;         /* File read/write count */

	char RWC[2]={0,0};

	if(strncmp(CMD[LIST],RX_CMD,4) == 0)	//Send out directory listing
	{
		res = scan_files(RX_ARG,ALL_T);
		return;
	}
	if(strncmp(CMD[LIST_FILES],RX_CMD,4) == 0)	//Send out directory listing
	{
		res = scan_files(RX_ARG,FILE_T);
		return;
	}
	if(strncmp(CMD[LIST_DIRS],RX_CMD,4) == 0)	//Send out directory listing
	{
		res = scan_files(RX_ARG,DIR_T);
		return;
	}
	if(strncmp(CMD[READ],RX_CMD,4) == 0)	//Read data from a file
	{
		temp = (((unsigned int)RX_ARG[0]<<8)|RX_ARG[1]);
		res = f_open(&fsrc,(RX_ARG+2),FA_READ);
		memset(Buffer,0,128); 
		res = f_lseek(&fsrc,temp);
      	res = f_read(&fsrc,Buffer, 128, &br);    /* Read a chunk of src file */

		RWC[0] = (char)(br >> 8);
		RWC[1] = (char)br & 0x00FF;
		UART_TX(RWC[0]);
		UART_TX(RWC[1]);
      	UART_STR(Buffer);

		return;
	}
	if(strncmp(CMD[WRITE],RX_CMD,4) == 0)	//Write data to a file
	{
		//res = pf_open(RX_ARG);
		return;
	}
	if(strncmp(CMD[APPEND],RX_CMD,4) == 0)	//Append data to a file
	{
		//res = pf_open(RX_ARG);
		return;
	}
}
