#ifndef MAIN_H
#define MAIN_H

#include <p18f4620.h>
#include <string.h>
#include "uart.h"
#include "diskio.h"
#include "ff.h"
#include "integer.h"
#include <delays.h>
#include <stdio.h>

extern FATFS fs;
extern char isMounted;

//DEFINITIONS
#define SD_CS_DIR TRISCbits.TRISC2		//Card Select Pin Direction Register
#define SD_CS  	  PORTCbits.RC2		//Card Select Pin Data Output

#define SD_CD_DIR TRISCbits.TRISC1		//Card Detect Pin Direction Register
#define SD_CD  	  PORTCbits.RC1			//Card Detect Pin Input Data

#define USE_DETECT 1					//Comment this out if not using the CARD DETECT

										//This will tell our MCU when we are busy and when we are free for commands
#define BUSY_DIR  TRISCbits.TRISC0		//BUSY Pin Direction Register
#define BUSY	  LATCbits.LATC0		//BUSY Pin Data Output

										//This will set our UART speed. 1 Pin has 2 possible outcomes, 0,1
#define SPEED_0_DIR TRISBbits.TRISB0	//LOWER BIT Direction Register
#define SPEED_0 PORTBbits.RB0			//LOWER BIT Input Data

//PROTOTYPES
void main(void);
void RunCommand(void);
FRESULT MountSD(void);
FRESULT scan_files (char* path,char type);

//LIST TYPES
#define DIR_T 0
#define FILE_T 1
#define ALL_T 2

extern char Buffer[64];
#endif